Index: /main/waeup.aaue/trunk/src/waeup/aaue/applicants/interfaces.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/applicants/interfaces.py	(revision 15265)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/applicants/interfaces.py	(revision 15266)
@@ -573,5 +573,5 @@
     date_of_birth = FormattedDate(
         title = _(u'Date of Birth'),
-        required = False,
+        required = True,
         #date_format = u'%d/%m/%Y', # Use grok-instance-wide default
         show_year = True,
@@ -581,5 +581,5 @@
         title = _(u'Place of Birth'),
         readonly = False,
-        required = False,
+        required = True,
         )
 
@@ -587,5 +587,5 @@
         vocabulary = nats_vocab,
         title = _(u'Nationality'),
-        required = False,
+        required = True,
         )
 
@@ -599,10 +599,10 @@
         title = _(u'Phone'),
         description = u'',
-        required = False,
+        required = True,
         )
 
     perm_address = schema.Text(
         title = _(u'Current Local Address'),
-        required = False,
+        required = True,
         readonly = False,
         )
@@ -611,5 +611,5 @@
         title = _(u'Dispatch Addresses'),
         description = u'Addresses to which transcript should be posted.',
-        required = False,
+        required = True,
         readonly = False,
         )
@@ -618,5 +618,5 @@
         title = _(u'Entry Mode'),
         source = StudyModeSource(),
-        required = False,
+        required = True,
         readonly = False,
         )
@@ -625,5 +625,5 @@
         title = _(u'Entry Session'),
         source = academic_sessions_vocab,
-        required = False,
+        required = True,
         readonly = False,
         )
@@ -632,5 +632,5 @@
         title = _(u'End Session'),
         source = academic_sessions_vocab,
-        required = False,
+        required = True,
         readonly = False,
         )
@@ -639,5 +639,5 @@
         title = _(u'Course of Study / Degree'),
         source = CertificateSource(),
-        required = False,
+        required = True,
         readonly = False,
         )
@@ -726,5 +726,5 @@
     date_of_birth = FormattedDate(
         title = _(u'Date of Birth'),
-        required = False,
+        required = True,
         #date_format = u'%d/%m/%Y', # Use grok-instance-wide default
         show_year = True,
@@ -734,5 +734,5 @@
         title = _(u'Place of Birth'),
         readonly = False,
-        required = False,
+        required = True,
         )
 
@@ -740,5 +740,5 @@
         vocabulary = nats_vocab,
         title = _(u'Nationality'),
-        required = False,
+        required = True,
         )
 
@@ -752,5 +752,5 @@
         title = _(u'Phone'),
         description = u'',
-        required = False,
+        required = True,
         )
 
@@ -758,5 +758,5 @@
         title = _(u'Entry Session'),
         source = academic_sessions_vocab,
-        required = False,
+        required = True,
         readonly = False,
         )
@@ -765,5 +765,5 @@
         title = _(u'End Session'),
         source = academic_sessions_vocab,
-        required = False,
+        required = True,
         readonly = False,
         )
@@ -779,5 +779,5 @@
         title = _(u'Certificate Type'),
         vocabulary = certificate_types_vocab,
-        required = False,
+        required = True,
         )
 
Index: /main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py	(revision 15265)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py	(revision 15266)
@@ -275,4 +275,12 @@
         self.browser.getControl(name="form.course_studied").value = ['CERT1']
         self.browser.getControl(name="form.matric_number").value = '234'
+        self.browser.getControl(name="form.place_of_birth").value = 'Bochum'
+        self.browser.getControl(name="form.dispatch_address").value = 'Kuensche'
+        self.browser.getControl(name="form.perm_address").value = 'Kuensche'
+        self.browser.getControl(name="form.entry_mode").value = ['ug_ft']
+        self.browser.getControl(name="form.entry_session").value = ['2014']
+        self.browser.getControl(name="form.end_session").value = ['2015']
+        self.browser.getControl(name="form.phone.country").value = ['+234']
+        self.browser.getControl(name="form.phone.ext").value = '5678'
         self.browser.getControl("Save").click()
         self.browser.getControl("Add online payment ticket").click()