Index: main/waeup.fceokene/trunk/src/waeup/fceokene/remita/browser.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/remita/browser.py	(revision 15273)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/remita/browser.py	(revision 15281)
@@ -29,12 +29,17 @@
 # Temporarily we can use the test portal like in kofacustom.nigeria
 
-from kofacustom.nigeria.remita.tests import (
-    MERCHANTID, HOST, HTTPS, API_KEY, SERVICETYPEID)
+#from kofacustom.nigeria.remita.tests import (
+#    MERCHANTID, HOST, HTTPS, API_KEY, SERVICETYPEID)
 
-#MERCHANTID = ''
-#HOST = 'login.remita.net'
-#HTTPS = True
-#API_KEY = ''
-#SERVICETYPEID = ''
+MERCHANTID = '3534555222'
+HOST = 'login.remita.net'
+HTTPS = True
+API_KEY = '756843'
+SERVICETYPEID = '365039884'
+
+PROVIDER_ACCT = '0773411069'
+PROVIDER_BANKCODE = '044'
+INSTITUTION_ACCT = '0270100161017'
+INSTITUTION_BANKCODE = '000'
 
 class CustomRemitaRequestPaymentStatusPageStudent(
@@ -75,14 +80,27 @@
     @property
     def lineitems(self):
-        ba1 = self.context.amount_auth / 2
-        ba2 = self.context.amount_auth / 2
-        lineitems = (
-                      {"lineItemsId":"itemid1","beneficiaryName":"Klaus Mueller",
-                      "beneficiaryAccount":"6020067886","bankCode":"011",
-                      "beneficiaryAmount":str(ba1),"deductFeeFrom":"1"},
-                      {"lineItemsId":"itemid2","beneficiaryName":"Werner Rumm",
-                      "beneficiaryAccount":"0360883515","bankCode":"050",
-                      "beneficiaryAmount":str(ba2),"deductFeeFrom":"0"}
-                    )
+        provider_amt = 1600.0
+        if 'maintenance' in self.context.p_category or \
+            self.context.p_category == 'clearance':
+            provider_amt = 0.0
+        inst_amt = self.context.amount_auth - provider_amt
+        if provider_amt:
+            lineitems = (
+                          {"lineItemsId":"itemid1","beneficiaryName":"FCEOkene",
+                          "beneficiaryAccount":INSTITUTION_ACCT,
+                          "bankCode":INSTITUTION_BANKCODE,
+                          "beneficiaryAmount":inst_amt,"deductFeeFrom":"1"},
+                          {"lineItemsId":"itemid2","beneficiaryName":"WAEAC",
+                          "beneficiaryAccount":PROVIDER_ACCT,
+                          "bankCode":PROVIDER_BANKCODE,
+                          "beneficiaryAmount":provider_amt,"deductFeeFrom":"0"}
+                        )
+        else:
+            lineitems = (
+                          {"lineItemsId":"itemid1","beneficiaryName":"FCEOkene",
+                          "beneficiaryAccount":inst_acct,"bankCode":inst_bankcode,
+                          "beneficiaryAmount":inst_amt,"deductFeeFrom":"1"},
+                        )
+        self.context.provider_amt = provider_amt
         return lineitems
 
@@ -136,12 +154,17 @@
     @property
     def lineitems(self):
+        provider_amt = 500.0
+        inst_amt = self.context.amount_auth - provider_amt
         lineitems = (
-                      {"lineItemsId":"itemid1","beneficiaryName":"Klaus Mueller",
-                      "beneficiaryAccount":"6020067886","bankCode":"011",
-                      "beneficiaryAmount":self.context.amount_auth/2,"deductFeeFrom":"1"},
-                      {"lineItemsId":"itemid2","beneficiaryName":"Werner Rumm",
-                      "beneficiaryAccount":"0360883515","bankCode":"050",
-                      "beneficiaryAmount":self.context.amount_auth/2,"deductFeeFrom":"0"}
+                          {"lineItemsId":"itemid1","beneficiaryName":"FCEOkene",
+                          "beneficiaryAccount":INSTITUTION_ACCT,
+                          "bankCode":INSTITUTION_BANKCODE,
+                          "beneficiaryAmount":inst_amt,"deductFeeFrom":"1"},
+                          {"lineItemsId":"itemid2","beneficiaryName":"WAEAC",
+                          "beneficiaryAccount":PROVIDER_ACCT,
+                          "bankCode":PROVIDER_BANKCODE,
+                          "beneficiaryAmount":provider_amt,"deductFeeFrom":"0"}
                     )
+        self.context.provider_amt = provider_amt
         return lineitems
 