Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/sample_container_data.csv
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/sample_container_data.csv	(revision 15284)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/sample_container_data.csv	(revision 15285)
@@ -1,7 +1,7 @@
 code,title,prefix,year,application_category,description,startdate,enddate,strict_deadline,mode
-app2014,General Studies,app,2014,basic,"This text can been seen by anonymous users.
+app2017,General Studies,app,2017,basic,"This text can been seen by anonymous users.
 >>de<<
 Dieser Text kann von anonymen Benutzern gelesen werden.",2012-03-01,2012-04-25,1,create
-app2015,General Studies,app,2015,basic,"This text can been seen by anonymous users.
+app2018,General Studies,app,2018,basic,"This text can been seen by anonymous users.
 >>de<<
 Dieser Text kann von anonymen Benutzern gelesen werden.",2013-03-01,2013-04-25,1,create
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_batching.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_batching.py	(revision 15284)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_batching.py	(revision 15285)
@@ -161,14 +161,14 @@
             self.csv_file, APPS_CONTAINER_HEADER_FIELDS)
         avail_containers = [x for x in self.app['applicants'].keys()]
-        container = self.app['applicants'].get('app2014', None)
-        container2 = self.app['applicants'].get('app2015', None)
+        container = self.app['applicants'].get('app2017', None)
+        container2 = self.app['applicants'].get('app2018', None)
         self.assertTrue(container is not None)
         self.assertTrue(container2 is not None)
 
         # check attributes
-        self.assertEqual(container.code, u'app2014')
+        self.assertEqual(container.code, u'app2017')
         self.assertEqual(container.title, u'General Studies')
         self.assertEqual(container.prefix, u'app')
-        self.assertEqual(container.year, 2014)
+        self.assertEqual(container.year, 2017)
         self.assertEqual(container.application_category, 'basic')
         self.assertEqual(
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 15284)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 15285)
@@ -3811,5 +3811,5 @@
             self.browser.headers['content-disposition'])
         self.assertTrue(
-            '666,12.12,2012-12-13 00:00:00#,schoolfee,1,my-id,p-item,100,2012,'
+            '666,12.12,2012-12-13 00:00:00#,schoolfee,1,my-id,p-item,100,2013,'
             'paid,2012-12-13 00:00:00#,12.12,r-code,,K1000000,234,123,Anna,,'
             'Tester,created,2004,2004,,fac1,dep1,CERT1' in self.browser.contents)
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 15284)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 15285)
@@ -1325,7 +1325,7 @@
             'student_id,matric_number,display_fullname,state,certcode,'
             'faccode,depcode,is_postgrad,current_level,current_session,'
-            'current_mode,entry_session,reg_number,schoolfee12,'
-            'schoolfee13,schoolfee14,clearance12,clearance13,clearance14,'
-            'gown12,gown13,gown14,transcript12,transcript13,transcript14\r\n'
+            'current_mode,entry_session,reg_number,schoolfee13,'
+            'schoolfee14,schoolfee15,clearance13,clearance14,clearance15,'
+            'gown13,gown14,gown15,transcript13,transcript14,transcript15\r\n'
             'A111111,234,Anna M. Tester,created,CERT1,NA,NA,0,200,'
             '2012,ug_ft,2010,123,'
@@ -1368,8 +1368,8 @@
             'depcode,is_postgrad,current_level,current_session,'
             'current_mode,entry_session,reg_number,'
-            'schoolfee12,schoolfee13,schoolfee14,'
-            'clearance12,clearance13,clearance14,'
-            'gown12,gown13,gown14,'
-            'transcript12,transcript13,transcript14\r\n'
+            'schoolfee13,schoolfee14,schoolfee15,'
+            'clearance13,clearance14,clearance15,'
+            'gown13,gown14,gown15,'
+            'transcript13,transcript14,transcript15\r\n'
             'A111111,234,Anna M. Tester,created,CERT1,NA,NA,0,200,2012,ug_ft,'
             '2010,123,'