Index: /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 15286)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 15287)
@@ -51,4 +51,5 @@
 from waeup.kofa.mandates.mandate import RefereeReportMandate
 from waeup.kofa.tests.test_async import FunctionalAsyncTestCase
+from waeup.kofa.tests.test_authentication import SECRET
 
 PH_LEN = 15911  # Length of placeholder file
@@ -539,5 +540,5 @@
     def init_officer(self):
         # Create application officer
-        self.app['users'].addUser('mrappl', 'mrapplsecret')
+        self.app['users'].addUser('mrappl', SECRET)
         self.app['users']['mrappl'].email = 'mrappl@foo.ng'
         self.app['users']['mrappl'].title = 'Carlo Pitter'
@@ -547,5 +548,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mrappl'
-        self.browser.getControl(name="form.password").value = 'mrapplsecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/authentication.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/authentication.py	(revision 15286)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/authentication.py	(revision 15287)
@@ -280,4 +280,8 @@
             # unset/empty passwords do never match
             return False
+        # Do not accept password if password is insecure.
+        validator = getUtility(IPasswordValidator)
+        if validator.validate_secure_password(password, password):
+            return False
         if self.suspended:
             return False
@@ -411,5 +415,5 @@
         return errors
 
-    def validate_secured_password(self, pw, pw_repeat):
+    def validate_secure_password(self, pw, pw_repeat):
         """
         ^(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9]).{8,}$
@@ -422,4 +426,9 @@
         $              End anchor.
         """
+
+        # temporarily disabled
+        # /kofa/trunk/src/waeup/kofa/doctests/pages.txt line 176 not met
+        return self.validate_password(pw, pw_repeat)
+
         check_pw = re.compile(r"^(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9]).{8,}$").match
         errors = []
@@ -427,5 +436,5 @@
             errors.append(translate(_(
                 'Passwords must be at least 8 characters long, '
-                'contain at least one uppercase letter, '
+                'must contain at least one uppercase letter, '
                 'one lowercase letter and one digit.')))
         if pw != pw_repeat:
Index: /main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 15286)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 15287)
@@ -430,5 +430,6 @@
                     return
             # Display appropriate flash message if credentials are correct
-            # but officer has been deactivated.
+            # but the stored password is insecure or officer has been
+            # deactivated.
             login = self.request.form['form.login']
             if login in grok.getSite()['users']:
@@ -438,6 +439,23 @@
                 if user.password is not None and \
                     passwordmanager.checkPassword(user.password, password):
+                    # Check first if the stored password might have
+                    # been the reason
+                    validator = getUtility(IPasswordValidator)
+                    errors = validator.validate_secure_password(
+                        password, password)
+                    if errors:
+                        msg1 = translate(_(
+                                 'Your user name and password are correct '
+                                 'but your password is not considered '
+                                 'secure. '))
+                        msg2 = translate(_(
+                                 ' Your account has been temporarily '
+                                 'deactivated. '
+                                 'Please request a new password.'))
+                        self.flash( msg1 + ' '.join(errors) + msg2, type="danger")
+                        self.redirect(self.application_url() + '/changepw')
+                        return
                     self.flash(_('Your user name and password are correct '
-                                 'but yor account has been temporarily '
+                                 'but your account has been temporarily '
                                  'deactivated.'),
                                type='warning')
@@ -859,5 +877,5 @@
         if password:
             validator = getUtility(IPasswordValidator)
-            errors = validator.validate_secured_password(password, password_ctl)
+            errors = validator.validate_secure_password(password, password_ctl)
             if errors:
                 self.flash( ' '.join(errors), type='danger')
@@ -903,5 +921,5 @@
         if password:
             validator = getUtility(IPasswordValidator)
-            errors = validator.validate_secured_password(password, password_ctl)
+            errors = validator.validate_secure_password(password, password_ctl)
             if errors:
                 self.flash( ' '.join(errors), type='danger')
Index: /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py	(revision 15286)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py	(revision 15287)
@@ -37,4 +37,5 @@
 from waeup.kofa.university.faculty import Faculty
 from waeup.kofa.university.department import Department
+from waeup.kofa.tests.test_authentication import SECRET
 
 SAMPLE_FILE = os.path.join(os.path.dirname(__file__), 'test_file.csv')
@@ -359,5 +360,5 @@
     def test_export_accesscodes(self):
         # Create portal manager and an ExportManager
-        self.app['users'].addUser('mrportal', 'mrportalsecret')
+        self.app['users'].addUser('mrportal', SECRET)
         self.app['users']['mrportal'].email = 'mrportal@foo.ng'
         self.app['users']['mrportal'].title = 'Carlo Pitter'
@@ -365,5 +366,5 @@
         prmlocal = IPrincipalRoleManager(self.app)
         prmlocal.assignRoleToPrincipal('waeup.PortalManager', 'mrportal')
-        self.app['users'].addUser('mrexporter', 'mrexportersecret')
+        self.app['users'].addUser('mrexporter', SECRET)
         self.app['users']['mrexporter'].email = 'mrexporter@foo.ng'
         self.app['users']['mrexporter'].title = 'Carlos Potter'
@@ -374,5 +375,5 @@
         self.browser.open('http://localhost/app/login')
         self.browser.getControl(name="form.login").value = 'mrportal'
-        self.browser.getControl(name="form.password").value = 'mrportalsecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
 
@@ -401,5 +402,5 @@
         self.browser.open('http://localhost/app/login')
         self.browser.getControl(name="form.login").value = 'mrexporter'
-        self.browser.getControl(name="form.password").value = 'mrexportersecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
 
@@ -501,5 +502,5 @@
         login_path = 'http://localhost/app/login'
         # Create  officer
-        self.app['users'].addUser('officer', 'officersecret')
+        self.app['users'].addUser('officer', SECRET)
         self.app['users']['officer'].email = 'mrofficer@foo.ng'
         self.app['users']['officer'].title = 'Carlo Pitter'
@@ -510,5 +511,5 @@
         self.browser.open(login_path)
         self.browser.getControl(name="form.login").value = 'officer'
-        self.browser.getControl(name="form.password").value = 'officersecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.browser.open(upload_path)
@@ -562,10 +563,10 @@
     def test_suspended_officer(self):
         self.app['users'].addUser(
-            'officer', 'secret', title='Bob Officer', email='bob@abcd.ng')
+            'officer', SECRET, title='Bob Officer', email='bob@abcd.ng')
         # Officer can't login if their password is not set.
         self.app['users']['officer'].password = None
         self.browser.open('http://localhost/app/login')
         self.browser.getControl(name="form.login").value = 'officer'
-        self.browser.getControl(name="form.password").value = 'secret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertTrue(
@@ -573,13 +574,13 @@
         # We set the password again.
         IUserAccount(
-            self.app['users']['officer']).setPassword('secret')
+            self.app['users']['officer']).setPassword(SECRET)
         # Officers can't login if their account is suspended/deactivated.
         self.app['users']['officer'].suspended = True
         self.browser.open('http://localhost/app/login')
         self.browser.getControl(name="form.login").value = 'officer'
-        self.browser.getControl(name="form.password").value = 'secret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertMatches(
-            '...but yor account has been temporarily deactivated...',
+            '...but your account has been temporarily deactivated...',
             self.browser.contents)
         # Officer is really not logged in.
@@ -588,5 +589,5 @@
         self.browser.open('http://localhost/app/login')
         self.browser.getControl(name="form.login").value = 'officer'
-        self.browser.getControl(name="form.password").value = 'secret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         # Yeah, officer logged in.
@@ -618,8 +619,8 @@
         config = grok.getSite()['configuration']
         self.app['users'].addUser(
-            'officer', 'secret', title='Bob Officer', email='bob@abcd.ng')
+            'officer', SECRET, title='Bob Officer', email='bob@abcd.ng')
         self.browser.open('http://localhost/app/login')
         self.browser.getControl(name="form.login").value = 'officer'
-        self.browser.getControl(name="form.password").value = 'secret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         # Officer logged in.
@@ -636,5 +637,5 @@
         # Officers really can't login if maintenance mode is enabled.
         self.browser.getControl(name="form.login").value = 'officer'
-        self.browser.getControl(name="form.password").value = 'secret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         # A second warning is raised.
@@ -645,5 +646,5 @@
         config.maintmode_enabled_by = u'officer'
         self.browser.getControl(name="form.login").value = 'officer'
-        self.browser.getControl(name="form.password").value = 'secret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertTrue('You logged in' in self.browser.contents)
Index: /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_permissions.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_permissions.py	(revision 15286)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_permissions.py	(revision 15287)
@@ -37,5 +37,5 @@
     remove_logger)
 from waeup.kofa.tests.test_async import FunctionalAsyncTestCase
-
+from waeup.kofa.tests.test_authentication import SECRET
 
 
@@ -157,5 +157,5 @@
     def testReportsPermissions(self):
         # Create reports officer
-        self.app['users'].addUser('mrofficer', 'mrofficer')
+        self.app['users'].addUser('mrofficer', SECRET)
         self.app['users']['mrofficer'].email = 'mrofficer@foo.ng'
         self.app['users']['mrofficer'].title = 'Otto Report'
@@ -163,5 +163,5 @@
         prmglobal.assignRoleToPrincipal('waeup.ReportsOfficer', 'mrofficer')
         # Create reports manager
-        self.app['users'].addUser('mrmanager', 'mrmanager')
+        self.app['users'].addUser('mrmanager', SECRET)
         self.app['users']['mrmanager'].email = 'mrmanager@foo.ng'
         self.app['users']['mrmanager'].title = 'Manfred Report'
@@ -171,5 +171,5 @@
         self.browser.open('http://localhost/app/login')
         self.browser.getControl(name="form.login").value = 'mrofficer'
-        self.browser.getControl(name="form.password").value = 'mrofficer'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.trigger_report_creation('2004')
@@ -184,5 +184,5 @@
         self.browser.open('http://localhost/app/login')
         self.browser.getControl(name="form.login").value = 'mrmanager'
-        self.browser.getControl(name="form.password").value = 'mrmanager'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.trigger_report_creation('2005')
@@ -199,5 +199,5 @@
         self.browser.open('http://localhost/app/login')
         self.browser.getControl(name="form.login").value = 'mrofficer'
-        self.browser.getControl(name="form.password").value = 'mrofficer'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.browser.open('http://localhost/app/reports')
Index: /main/waeup.kofa/trunk/src/waeup/kofa/doctests/authentication.txt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/doctests/authentication.txt	(revision 15286)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/doctests/authentication.txt	(revision 15287)
@@ -30,5 +30,5 @@
 terms) with a password (and optional a title or description):
 
-  >>> root['app']['users'].addUser('bob', 'bobsecret',
+  >>> root['app']['users'].addUser('bob', 'bobSecret1',
   ...                           title='Bob', description='A sample user')
 
@@ -186,5 +186,5 @@
 
   >>> browser.getControl(name='form.login').value = 'bob'
-  >>> browser.getControl(name='form.password').value = 'bobsecret'
+  >>> browser.getControl(name='form.password').value = 'bobSecret1'
   >>> browser.getControl('Login').click()
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/interfaces.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/interfaces.py	(revision 15286)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/interfaces.py	(revision 15287)
@@ -649,5 +649,5 @@
         """
 
-    def validate_secured_password(self, pw, pw_repeat):
+    def validate_secure_password(self, pw, pw_repeat):
         """ Validates a password by comparing it with
         control password and checks password strength by
Index: /main/waeup.kofa/trunk/src/waeup/kofa/mandates/tests.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/mandates/tests.py	(revision 15286)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/mandates/tests.py	(revision 15287)
@@ -34,4 +34,5 @@
 from waeup.kofa.mandates.mandate import PasswordMandate, RefereeReportMandate
 from waeup.kofa.testing import (FunctionalLayer, FunctionalTestCase)
+from waeup.kofa.tests.test_authentication import SECRET
 
 class MandatesContainerTestCase(FunctionalTestCase):
@@ -123,9 +124,9 @@
 
     def test_set_officer_password(self):
-        self.app['users'].addUser('bob', 'bobssecret')
+        self.app['users'].addUser('bob', SECRET)
         officer = self.app['users']['bob']
         mandate = PasswordMandate()
         mandate.params['user'] = officer
-        mandate.params['password'] = 'mypwd1'
+        mandate.params['password'] = SECRET
         self.app['mandates'].addMandate(mandate)
         (msg, redirect_path) = mandate.execute()
@@ -134,5 +135,5 @@
             'Password has been successfully set. Login with your new password.')
         self.assertEqual(redirect_path, '/login')
-        self.assertTrue(IUserAccount(officer).checkPassword('mypwd1'))
+        self.assertTrue(IUserAccount(officer).checkPassword(SECRET))
         logfile = os.path.join(
             self.app['datacenter'].storage, 'logs', 'main.log')
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 15286)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 15287)
@@ -53,4 +53,5 @@
 from waeup.kofa.tests.test_async import FunctionalAsyncTestCase
 from waeup.kofa.browser.tests.test_pdf import samples_dir
+from waeup.kofa.tests.test_authentication import SECRET
 
 PH_LEN = 15911  # Length of placeholder file
@@ -1521,5 +1522,5 @@
     def init_clearance_officer(self):
         # Create clearance officer
-        self.app['users'].addUser('mrclear', 'mrclearsecret')
+        self.app['users'].addUser('mrclear', SECRET)
         self.app['users']['mrclear'].email = 'mrclear@foo.ng'
         self.app['users']['mrclear'].title = 'Carlo Pitter'
@@ -1543,5 +1544,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mrclear'
-        self.browser.getControl(name="form.password").value = 'mrclearsecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
 
@@ -1702,5 +1703,5 @@
 
     def test_handle_courses_by_ca(self):
-        self.app['users'].addUser('mrsadvise', 'mrsadvisesecret')
+        self.app['users'].addUser('mrsadvise', SECRET)
         self.app['users']['mrsadvise'].email = 'mradvise@foo.ng'
         self.app['users']['mrsadvise'].title = u'Helen Procter'
@@ -1713,5 +1714,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mrsadvise'
-        self.browser.getControl(name="form.password").value = 'mrsadvisesecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertMatches('...You logged in...', self.browser.contents)
@@ -1851,5 +1852,5 @@
     def test_find_students_in_faculties(self):
         # Create local students manager in faculty
-        self.app['users'].addUser('mrmanager', 'mrmanagersecret')
+        self.app['users'].addUser('mrmanager', SECRET)
         self.app['users']['mrmanager'].email = 'mrmanager@foo.ng'
         self.app['users']['mrmanager'].title = u'Volk Wagen'
@@ -1865,5 +1866,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mrmanager'
-        self.browser.getControl(name="form.password").value = 'mrmanagersecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertMatches('...You logged in...', self.browser.contents)
@@ -2021,5 +2022,5 @@
         # StudentImpersonators can login as student
         # Create clearance officer
-        self.app['users'].addUser('mrofficer', 'mrofficersecret')
+        self.app['users'].addUser('mrofficer', SECRET)
         self.app['users']['mrofficer'].email = 'mrofficer@foo.ng'
         self.app['users']['mrofficer'].title = 'Harry Actor'
@@ -2030,5 +2031,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mrofficer'
-        self.browser.getControl(name="form.password").value = 'mrofficersecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertMatches('...You logged in...', self.browser.contents)
@@ -2128,5 +2129,5 @@
             'Address line2\n\n')
         # Create officer with both roles
-        self.app['users'].addUser('mrtranscript', 'mrtranscriptsecret')
+        self.app['users'].addUser('mrtranscript', SECRET)
         self.app['users']['mrtranscript'].email = 'mrtranscript@foo.ng'
         self.app['users']['mrtranscript'].title = 'Ruth Gordon'
@@ -2138,5 +2139,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mrtranscript'
-        self.browser.getControl(name="form.password").value = 'mrtranscriptsecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertMatches('...You logged in...', self.browser.contents)
@@ -2274,5 +2275,5 @@
         notify(grok.ObjectModifiedEvent(self.student))
         # Create transcript officer
-        self.app['users'].addUser('mrtranscript', 'mrtranscriptsecret')
+        self.app['users'].addUser('mrtranscript', SECRET)
         self.app['users']['mrtranscript'].email = 'mrtranscript@foo.ng'
         self.app['users']['mrtranscript'].title = 'Ruth Gordon'
@@ -2287,5 +2288,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mrtranscript'
-        self.browser.getControl(name="form.password").value = 'mrtranscriptsecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertMatches('...You logged in...', self.browser.contents)
@@ -2315,5 +2316,5 @@
         notify(grok.ObjectModifiedEvent(self.student))
         # Create transcript signee
-        self.app['users'].addUser('mrtranscript', 'mrtranscriptsecret')
+        self.app['users'].addUser('mrtranscript', SECRET)
         self.app['users']['mrtranscript'].email = 'mrtranscript@foo.ng'
         self.app['users']['mrtranscript'].title = 'Ruth Gordon'
@@ -2328,5 +2329,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mrtranscript'
-        self.browser.getControl(name="form.password").value = 'mrtranscriptsecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertMatches('...You logged in...', self.browser.contents)
@@ -4111,5 +4112,5 @@
     def test_export_departmet_officers(self):
         # Create department officer
-        self.app['users'].addUser('mrdepartment', 'mrdepartmentsecret')
+        self.app['users'].addUser('mrdepartment', SECRET)
         self.app['users']['mrdepartment'].email = 'mrdepartment@foo.ng'
         self.app['users']['mrdepartment'].title = 'Carlo Pitter'
@@ -4121,5 +4122,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mrdepartment'
-        self.browser.getControl(name="form.password").value = 'mrdepartmentsecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertMatches('...You logged in...', self.browser.contents)
@@ -4145,5 +4146,5 @@
     def test_export_bursary_officers(self):
         # Create bursary officer
-        self.app['users'].addUser('mrbursary', 'mrbursarysecret')
+        self.app['users'].addUser('mrbursary', SECRET)
         self.app['users']['mrbursary'].email = 'mrbursary@foo.ng'
         self.app['users']['mrbursary'].title = 'Carlo Pitter'
@@ -4153,5 +4154,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mrbursary'
-        self.browser.getControl(name="form.password").value = 'mrbursarysecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertMatches('...You logged in...', self.browser.contents)
@@ -4183,5 +4184,5 @@
     def test_export_accommodation_officers(self):
         # Create bursary officer
-        self.app['users'].addUser('mracco', 'mraccosecret')
+        self.app['users'].addUser('mracco', SECRET)
         self.app['users']['mracco'].email = 'mracco@foo.ng'
         self.app['users']['mracco'].title = 'Carlo Pitter'
@@ -4191,5 +4192,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mracco'
-        self.browser.getControl(name="form.password").value = 'mraccosecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         self.assertMatches('...You logged in...', self.browser.contents)
@@ -4234,5 +4235,5 @@
 
     def login_as_lecturer(self):
-        self.app['users'].addUser('mrslecturer', 'mrslecturersecret')
+        self.app['users'].addUser('mrslecturer', SECRET)
         self.app['users']['mrslecturer'].email = 'mrslecturer@foo.ng'
         self.app['users']['mrslecturer'].title = u'Mercedes Benz'
@@ -4253,5 +4254,5 @@
         self.browser.getControl(name="form.login").value = 'mrslecturer'
         self.browser.getControl(
-            name="form.password").value = 'mrslecturersecret'
+            name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         # Store reused urls/paths
Index: /main/waeup.kofa/trunk/src/waeup/kofa/tests/test_authentication.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/tests/test_authentication.py	(revision 15286)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/tests/test_authentication.py	(revision 15287)
@@ -40,4 +40,5 @@
     IKofaPluggable)
 
+SECRET = 'HgtuZZZ8'
 
 class FakeSite(grok.Site, grok.Container):
@@ -133,5 +134,5 @@
         self.getRootFolder()['app'] = FakeSite()
         self.site = self.getRootFolder()['app']
-        self.site['users'] = {'bob': Account('bob', 'secret')}
+        self.site['users'] = {'bob': Account('bob', SECRET)}
         setSite(self.site)
         return
@@ -155,5 +156,5 @@
         plugin = UserAuthenticatorPlugin()
         result1 = plugin.authenticateCredentials(
-            dict(login='bob', password='secret'))
+            dict(login='bob', password=SECRET))
         result2 = plugin.authenticateCredentials(
             dict(login='bob', password='nonsense'))
@@ -185,5 +186,5 @@
         # do `num` failed logins and a valid one afterwards
         del self.site['users']
-        self.site['users'] = {'bob': Account('bob', 'secret')}
+        self.site['users'] = {'bob': Account('bob', SECRET)}
         plugin = UserAuthenticatorPlugin()
         resultlist = []
@@ -193,5 +194,5 @@
                 dict(login='bob', password='wrongsecret')))
         resultlist.append(plugin.authenticateCredentials(
-            dict(login='bob', password='secret')))
+            dict(login='bob', password=SECRET)))
         return resultlist
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/utils/utils.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/utils/utils.py	(revision 15286)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/utils/utils.py	(revision 15287)
@@ -273,8 +273,11 @@
             name.replace('-', ' - ')).replace(' - ', '-')
 
-    def genPassword(self, length=8, chars=string.letters + string.digits):
+    def genPassword(self, length=4, chars=string.letters + string.digits):
         """Generate a random password.
         """
-        return ''.join([r().choice(chars) for i in range(length)])
+        return ''.join([
+            r().choice(string.uppercase) +
+            r().choice(string.lowercase) +
+            r().choice(string.digits) for i in range(length)])
 
     def sendCredentials(self, user, password=None, url_info=None, msg=None):