Index: /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser.py
===================================================================
--- /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser.py	(revision 15293)
+++ /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser.py	(revision 15294)
@@ -70,5 +70,5 @@
         Faculty = translate(_('Faculty'), 'waeup.kofa', target_language=portal_language)
         Cred = translate(_('Cred.'), 'waeup.kofa', target_language=portal_language)
-        #Mand = translate(_('Requ.'), 'waeup.kofa', target_language=portal_language)
+        CC = translate(_('Cat.'), target_language=portal_language)
         Score = translate(_('Score'), 'waeup.kofa', target_language=portal_language)
         Grade = translate(_('Grade'), 'waeup.kofa', target_language=portal_language)
@@ -87,8 +87,7 @@
                              (Dept,'dcode', 1.5), (Faculty,'fcode', 1.5),
                              (Cred, 'credits', 1.5),
-                             #(Mand, 'mandatory', 1.5),
+                             (CC, 'course_category', 1.2),
                              (Score, 'score', 1.5),
                              (Grade, 'grade', 1.5),
-                             #('Auto', 'automatic', 1.5)
                              ])
         return students_utils.renderPDF(
Index: /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser_templates/studyleveleditpage.pt
===================================================================
--- /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser_templates/studyleveleditpage.pt	(revision 15293)
+++ /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser_templates/studyleveleditpage.pt	(revision 15294)
@@ -21,4 +21,5 @@
       <th i18n:translate="">CO</th>
       <th i18n:translate="">OS</th>
+      <th i18n:translate="">CC</th>
     </tr>
   </thead>
@@ -41,4 +42,5 @@
       <td tal:content="value/carry_over">CO</td>
       <td tal:content="value/outstanding">OS</td>
+      <td tal:content="value/course_category">CC</td>
     </tr>
   </tbody>
Index: /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser_templates/studylevelmanagepage.pt
===================================================================
--- /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser_templates/studylevelmanagepage.pt	(revision 15293)
+++ /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser_templates/studylevelmanagepage.pt	(revision 15294)
@@ -48,4 +48,5 @@
             <th i18n:translate="">CO</th>
             <th i18n:translate="">OS</th>
+            <th i18n:translate="">CC</th>
             <th i18n:translate="">Auto</th>
           </tr>
@@ -69,4 +70,5 @@
             <td tal:content="value/carry_over">CO</td>
             <td tal:content="value/outstanding">OS</td>
+            <td tal:content="value/course_category">CC</td>
             <td tal:content="value/automatic">AUTO</td>
           </tr>
Index: /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser_templates/studylevelpage.pt
===================================================================
--- /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser_templates/studylevelpage.pt	(revision 15293)
+++ /main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/browser_templates/studylevelpage.pt	(revision 15294)
@@ -32,4 +32,5 @@
       <th i18n:translate="">CO</th>
       <th i18n:translate="">OS</th>
+      <th i18n:translate="">CC</th>
       <th i18n:translate="">Auto</th>
     </tr>
@@ -50,4 +51,5 @@
       <td tal:content="value/carry_over">CO</td>
       <td tal:content="value/outstanding">OS</td>
+      <td tal:content="value/course_category|nothing">CC</td>
       <td tal:content="value/automatic">AUTO</td>
     </tr>
@@ -58,4 +60,5 @@
   CO: Carry-over course<br />
   OS: Outstanding course<br />
+  CC: Course Category (C or E)<br />
   Requ.: Required course<br />
   Auto: Automatically created course ticket