Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/tests.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/tests.py	(revision 15270)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/tests.py	(revision 15351)
@@ -204,5 +204,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'action="http://www.remitademo.net/remita/ecomm/finalize.reg"'
+            'action="https://www.remitademo.net/remita/ecomm/finalize.reg"'
             in self.browser.contents)
         self.assertEqual(self.payment.r_company, 'remita')
@@ -235,5 +235,5 @@
         self.payment.p_id = self.orderId
         self.browser.getLink("Requery Remita Payment Status").click()
-        self.assertTrue('Successful payment' in self.browser.contents)
+        self.assertTrue('Payment successfully completed' in self.browser.contents)
         self.assertEqual(self.payment.r_desc, 'Approved')
         self.assertEqual(self.payment.r_amount_approved , 1000.0)
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/webservices.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/webservices.py	(revision 15270)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/webservices.py	(revision 15351)
@@ -38,5 +38,5 @@
     merchantId = '2547916'
     host = 'www.remitademo.net'
-    https = False
+    https = True
     api_key = '1946'
 
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/export.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/export.py	(revision 15270)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/export.py	(revision 15351)
@@ -96,5 +96,22 @@
             'state','current_session',
             'entry_session', 'entry_mode',
-            'faccode', 'depcode','certcode')
+            'faccode', 'depcode','certcode','lga')
+
+    def mangle_value(self, value, name, context=None):
+        """The mangler fetches the student data.
+        """
+        if context is not None:
+            student = context.student
+            if name in [
+                'student_id','matric_number', 'reg_number',
+                'firstname', 'middlename', 'lastname',
+                'state', 'current_session',
+                'entry_session', 'entry_mode',
+                'faccode', 'depcode', 'certcode',
+                'lga'] and student is not None:
+                value = getattr(student, name, None)
+        return super(
+            StudentPaymentExporter, self).mangle_value(
+            value, name, context=context)
 
 class ClearanceRequestedStudentExporter(StudentExporter):
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_browser.py	(revision 15270)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_browser.py	(revision 15351)
@@ -37,4 +37,5 @@
 from waeup.kofa.students.interfaces import IStudentsUtils
 from waeup.kofa.browser.tests.test_pdf import samples_dir
+from waeup.kofa.tests.test_authentication import SECRET
 from kofacustom.nigeria.students.batching import NigeriaStudentProcessor
 from kofacustom.nigeria.testing import FunctionalLayer
@@ -352,5 +353,5 @@
 
     def test_financial_clearance(self):
-        self.app['users'].addUser('mrbursary', 'mrbursarysecret')
+        self.app['users'].addUser('mrbursary', SECRET)
         self.app['users']['mrbursary'].email = 'mrbursary@foo.ng'
         self.app['users']['mrbursary'].title = u'Carlo Pitter'
@@ -367,5 +368,5 @@
         self.browser.open(self.login_path)
         self.browser.getControl(name="form.login").value = 'mrbursary'
-        self.browser.getControl(name="form.password").value = 'mrbursarysecret'
+        self.browser.getControl(name="form.password").value = SECRET
         self.browser.getControl("Login").click()
         # BO can see his roles
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_export.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_export.py	(revision 15270)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_export.py	(revision 15351)
@@ -26,5 +26,5 @@
 from kofacustom.nigeria.students.export import (
     NigeriaStudentExporter, NigeriaStudentPaymentExporter,
-    ClearanceRequestedStudentExporter)
+    ClearanceRequestedStudentExporter, NigeriaDataForBursaryExporter)
 from kofacustom.nigeria.testing import FunctionalLayer
 
@@ -168,2 +168,34 @@
             )
         return
+
+class BursaryDataExporterTest(StudentImportExportSetup):
+
+    layer = FunctionalLayer
+
+    def setUp(self):
+        super(BursaryDataExporterTest, self).setUp()
+        self.setup_for_export()
+        return
+
+    def test_export_all(self):
+        # we can really export all payments
+        # set values we can expect in export file
+        self.setup_student(self.student)
+        exporter = NigeriaDataForBursaryExporter()
+        exporter.export_all(self.app, self.outfile)
+        result = open(self.outfile, 'rb').read()
+        self.assertEqual(
+            result,
+            'ac,amount_auth,creation_date,formatted_p_date,gateway_amt,'
+            'p_category,p_current,p_id,p_item,p_level,p_session,p_state,'
+            'payment_date,provider_amt,r_amount_approved,r_card_num,r_code,'
+            'r_company,r_desc,r_pay_reference,thirdparty_amt,student_id,'
+            'matric_number,reg_number,firstname,middlename,lastname,state,'
+            'current_session,entry_session,entry_mode,faccode,depcode,certcode,lga\r\n'
+
+            '666,12.12,%s-04-01 13:12:01#,,,schoolfee,1,my-id,p-item,'
+            '100,%s,paid,%s-04-01 14:12:01#,,12.12,,r-code,,,,,A111111,'
+            '234,123,Anna,M.,Tester,created,2012,2010,ug_ft,NA,NA,CERT1,\r\n'
+            % (curr_year-6, curr_year-6, curr_year-6)
+            )
+        return